#include "sys.h"
#include "usart.h"
#include "tftlcd.h"
#include"ASR_LD3320.h"
#include "ASRlist.h"
#define        RESUM_OF_MUSIC               0x01
#define        CAUSE_MP3_SONG_END           0x20

#define        MASK_INT_SYNC				0x10
#define        MASK_INT_FIFO				0x04
#define    	   MASK_AFIFO_INT				0x01
#define        MASK_FIFO_STATUS_AFULL		0x08
u32 nMp3StartPos=0;
u32 nMp3Size=0;
u32 nMp3Pos=0;
u32 nCurMp3Pos=0;
u8 nLD_Mode = LD_MODE_IDLE;		//	¼ǰڽASRʶڲMP3
u8 bMp3Play=0;					//	¼MP3״̬
u8 nAsrStatus;
u8 nAsrRes;
u8 ucRegVal;
u8 ucHighInt;
u8 ucLowInt;
u8 ucStatus;
u8 ucSPVol=15; // MAX=15 MIN=0		//	Speaker
u8 bpDemoSound[100]={
0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF2,0xE5,0x33,0xA0,0xA4,0x31,0x8C,0x69,0x41,0xF4,

0x08,0x88,0x00,0x03,0xC1,0x2F,0x16,0x80,0x69,0x6E,0xEC,0xE9,0x28,0xB9,0xB6,0x51,

0x14,0x1C,0xFF,0xE2,0x10,0xC0,0x19,0x5C,0x38,0x09,0x49,0x92,0xDC,0xC8,0x84,0x04,

0x90,0xBB,0xFF,0xFF,0xFF,0xFF,0xFE,0x0D,0x3B,0xE9,0xFC,0xB3,0xEB,0x01,0xF8,0x30,

0x01,0x3F,0x78,0xF4,0x80,0x14,0x20,0x3D,0x57,0x5A,0x6A,0x27,0x44,0xE9,0x54,0xE9,

0x96,0x8B,0xA5,0x43,0x0A,0xB0,0xFF,0xE2,0x10,0xC0,0x90,0xBC,0x37,0x07,0x80,0x5A

};



void LD3320_reset(void)
{
	LD_RSTB=1;
	delay_ms(1);
	LD_RSTB=0;
	delay_ms(1);
	LD_RSTB=1;

	LD3320_SCS=1;
	delay_ms(1);
	LD3320_SCS=0;
	delay_ms(1);
	LD3320_SCS=1;
	delay_ms(1);
}
void DL3320_SPI_WriteByte(u8 byte)
{
	u8 i;
	for (i=0;i < 8; i++)
	{
		if ((byte & 0x80) == 0x80) 
			LD3320_MOSI = 1;
		else
			LD3320_MOSI = 0;

		delay_us(2);                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
		LD3320_SCK = 0;
		byte = (byte << 1);  
		delay_us(2);
		LD3320_SCK = 1;  
	}
}
u8 DL3320_SPI_ReadByte(u8 datain)
{
	u8 temp,i;
	for (i=0;i < 8; i++)
	{
		datain = (datain << 1);
		delay_us(2);
		LD3320_SCK = 0; 
		temp = LD3320_MISO;
		if (temp == 1)  
			datain |= 0x01; 
 		delay_us(2);
		LD3320_SCK = 1;  
	}
	return datain;
}
/*
  дĴ
*/
void LD_WriteReg(unsigned char address,unsigned char dataout)
{
	unsigned char command=0x04;
	LD3320_SCS=0;
	delay_us(1);
	DL3320_SPI_WriteByte(command);
	DL3320_SPI_WriteByte(address);
	DL3320_SPI_WriteByte(dataout);
	delay_us(1);		
	LD3320_SCS=1;
}
unsigned char LD_ReadReg(unsigned char address)
{				  
	unsigned char datain =0 ;
	unsigned char command=0x05;
	LD3320_SCS=0;
	delay_us(1);							
	DL3320_SPI_WriteByte(command);			 //write command
	DL3320_SPI_WriteByte(address);		 	//write address
	delay_us(1);
	datain=DL3320_SPI_ReadByte(datain);	 	//Read data
	delay_us(1);
	LD3320_SCS=1;
	return datain;
}

/*
 оƬǷæ
*/
u8 LD_Check_ASRBusyFlag_b2(void)
{
	u8 j;
	u8 flag = 0;
	for (j=0; j<10; j++)
	{
		if (LD_ReadReg(0xb2) == 0x21)
		{
			flag = 1;
			break;
		}
		delay_ms(10);		
	}
	return flag;
}
void LD_Init_Common()
{
	bMp3Play = 0;

	LD_ReadReg(0x06);  					  
	LD_WriteReg(0x17, 0x35); 					//λ
	delay_ms(10);
	LD_ReadReg(0x06);  

	LD_WriteReg(0x89, 0x03);  				   //ģ·ʼ
	delay_ms(5);
	LD_WriteReg(0xCF, 0x43);   				   //ڲʡʼ
	delay_ms(5);
	LD_WriteReg(0xCB, 0x02);				   //󲹽4ֵ
	
	/*PLL setting*/	
	LD_WriteReg(0x11, LD_PLL_11);     
	if (nLD_Mode == LD_MODE_MP3)
	{
		LD_WriteReg(0x1E, 0x00); 
		LD_WriteReg(0x19, LD_PLL_MP3_19);   
		LD_WriteReg(0x1B, LD_PLL_MP3_1B);   
		LD_WriteReg(0x1D, LD_PLL_MP3_1D);
	}
	else
	{
		LD_WriteReg(0x1E,0x00);
		LD_WriteReg(0x19, LD_PLL_ASR_19); 
		LD_WriteReg(0x1B, LD_PLL_ASR_1B);		
	    LD_WriteReg(0x1D, LD_PLL_ASR_1D);
	}
	delay_ms(10);
	
	LD_WriteReg(0xCD, 0x04);				//
	LD_WriteReg(0x17, 0x4c); 				//DSP
	delay_ms(5);
	LD_WriteReg(0xB9, 0x00);				//ʼַ
	LD_WriteReg(0xCF, 0x4f); 				//mp3ASRʼ
}

void LD_Init_MP3()							//ųʼ
{
	nLD_Mode = LD_MODE_MP3;
	LD_Init_Common();

	LD_WriteReg(0xBD,0x02);				   //ΪMP3ģʽ
	LD_WriteReg(0x17, 0x48);			   //߻
	delay_ms(10);

	LD_WriteReg(0x85, 0x52); 			   //ʼ
	LD_WriteReg(0x8F, 0x00);  			   //ʼ
	LD_WriteReg(0x81, 0x00);			   //
	LD_WriteReg(0x83, 0x00);			   //Ҷ
	LD_WriteReg(0x8E, 0xff);			   //	ֵԽԽ
	LD_WriteReg(0x8D, 0xff);			   //ʼ
    delay_ms(1);
	LD_WriteReg(0x87, 0xff);			   //ųʼ
	LD_WriteReg(0x89, 0xff);			   //ģ·תMP3ģʽ
	delay_ms(1);
	LD_WriteReg(0x22, 0x00);    		   //FIFO->
	LD_WriteReg(0x23, 0x00);
	LD_WriteReg(0x20, 0xef);    
	LD_WriteReg(0x21, 0x07);
	LD_WriteReg(0x24, 0x77);          	   
    LD_WriteReg(0x25, 0x03);
    LD_WriteReg(0x26, 0xbb);    
    LD_WriteReg(0x27, 0x01); 			   //<-FIFO
}
void LD_AdjustMIX2SPVolume(u8 val)		   //  8eĴ valʾֵΧ0-15
{
	ucSPVol = val;
	val = ((15-val)&0x0f) << 2;
	LD_WriteReg(0x8E, val | 0xc3); 
//	LD_WriteReg(0x87, 0x78); 
}	
void LD_Init_ASR()						//ʶʼ
{
	nLD_Mode=LD_MODE_ASR_RUN;
	LD_Init_Common();			   //ʼ

	LD_WriteReg(0xBD, 0x00);	   //ASRģ
	LD_WriteReg(0x17, 0x48);	   //DSP
	delay_ms( 10 );

	LD_WriteReg(0x3C, 0x80);       //FIFO޵
	LD_WriteReg(0x3E, 0x07);	   //FIFO޸
	LD_WriteReg(0x38, 0xff);       //FIFO޵
	LD_WriteReg(0x3A, 0x07);	   //FIFO޵
	
	LD_WriteReg(0x40, 0);          
	LD_WriteReg(0x42, 8);
	LD_WriteReg(0x44, 0);    
	LD_WriteReg(0x46, 8); 
	delay_ms( 1 );
}

//	ʶؼ߿ѧϰ"ʶоƬLD3320߽ؼ.pdf"йմ÷
u8 LD_AsrAddFixed(void)
{
	u8 k, flag;
	u8 nAsrAddLength;
	 char sRecog[7][8] = {"tuoba","wu", "liu", 
		"qi", "ba", "jiu","shi"};
	 u8 pCode[8] = {1, 5, 6, 7, 8,9,10};
		
	flag = 1;
	for (k=0; k<8; k++)
	{
			
		if(LD_Check_ASRBusyFlag_b2() == 0)
		{
			flag = 0;
			break;
		}
		
		LD_WriteReg(0xc1, pCode[k] );			 //дʶ𷵻صֱ
		LD_WriteReg(0xc3, 0 );					 //ȷд
		LD_WriteReg(0x08, 0x04);
		delay_ms(1);
		LD_WriteReg(0x08, 0x00);
		delay_ms(1);								 //ΪFIFO_EXT

		for (nAsrAddLength=0; nAsrAddLength<79; nAsrAddLength++)
		{
			if (sRecog[k][nAsrAddLength] == 0)
				break;
			LD_WriteReg(0x5, sRecog[k][nAsrAddLength]);
		}										//FIFO_EXTݿڼ
		LD_WriteReg(0xb9, nAsrAddLength);		//ǰַ
		LD_WriteReg(0xb2, 0xff);				//״̬лȳ0x21
		LD_WriteReg(0x37, 0x04);				//ָ_ӹؼ
	}
    return flag;
}

u8 LD_AsrAddFixed2(u8 ASR_list_num)
{
	u8 k, flag;
	u8 nAsrAddLength;
		
	flag = 1;
	for (k=0; k<5; k++)
	{
			
		if(LD_Check_ASRBusyFlag_b2() == 0)
		{
			flag = 0;
			break;
		}
		
		LD_WriteReg(0xc1, CtrlList1[ASR_list_num][k].Code );			 //дʶ𷵻صֱ
		LD_WriteReg(0xc3, 0 );					 //ȷд

		LD_WriteReg(0x08, 0x04);
		delay_ms(1);
		LD_WriteReg(0x08, 0x00);
		delay_ms(1);								 //ΪFIFO_EXT

		for (nAsrAddLength=0; nAsrAddLength<50; nAsrAddLength++)
		{
			if (CtrlList1[ASR_list_num][k].PinYin[nAsrAddLength] == 0)
				break;
			LD_WriteReg(0x5,CtrlList1[ASR_list_num][k].PinYin[nAsrAddLength]);
		}										//FIFO_EXTݿڼ
		LD_WriteReg(0xb9, nAsrAddLength);		//ǰַ
		LD_WriteReg(0xb2, 0xff);				//״̬лȳ0x21
		LD_WriteReg(0x37, 0x04);				//ָ_ӹؼ
	}
    return flag;
}
/*
  ʶ
*/
u8 LD_AsrRun(void)
{
	LD_WriteReg(0x35, MIC_VOL);				//ADC
	LD_WriteReg(0x1C, 0x09);				//ADC  0b˷	   07
	LD_WriteReg(0xBD, 0x20);				//ѡģ 20 00 ASR  02MP3
	LD_WriteReg(0x08, 0x01);				//FIFO 01DATA  02EXT
	delay_ms( 1 );
	LD_WriteReg(0x08, 0x00);				//FIFO_DATA
	delay_ms( 1 );

	if(LD_Check_ASRBusyFlag_b2() == 0)		//оƬǷæ
	{
		return 0;
	}

	LD_WriteReg(0xB2, 0xff);	
	LD_WriteReg(0x37, 0x06);				//ʶ 04 06ʼʶ
	delay_ms( 5 );
	LCD_ShowString(0,0,"0xBF");
	LCD_ShowNum(40,0,LD_ReadReg(0xBf),3,16);	   //ʾ˵ASRʶɹ
	LD_WriteReg(0x1C, 0x0b);				//ADC ˷
	LD_WriteReg(0x29, 0x10);				//ж
	LD_WriteReg(0xBD, 0x00);				//ʶ
	return 1;
}
/*
  ȡʶ
*/
u8 LD_GetResult(void)
{
	unsigned char receive_res;
	receive_res = LD_ReadReg(0xc5);			  //LD_ReadReg(0xc5); LD_ReadReg(0xc7); LD_ReadReg(0xc9); LD_ReadReg(0xcb);	   ɸݳѡ0xc5
	return receive_res;
}



void LD_ReloadMp3Data(u32 sound_size)		 //װMP3	Ҫ޸
{
	u8 val;
	ucStatus = LD_ReadReg(0x06);
	while ( !(ucStatus&MASK_FIFO_STATUS_AFULL) )
	{
		val = data1[nMp3Pos++];		//MP3ֵ
		LD_WriteReg(0x01,val);				//MP3ֵFIFO
		if ( data1[nMp3Pos]==0)
		{
			nMp3Pos=0;
			return;
		 }
		ucStatus = LD_ReadReg(0x06);
		
	}

}

void LD_ReloadMp3Data2(u32 sound_size)		 //װMP3	Ҫ޸
{
	u8 val;
	ucStatus = LD_ReadReg(0x06);
	while ( !(ucStatus&MASK_FIFO_STATUS_AFULL) )
	{
		val = bpDemoSound[nMp3Pos++];		//MP3ֵ
		LD_WriteReg(0x01,val);				//MP3ֵFIFO
		if ( bpDemoSound[nMp3Pos]==0)
		{
			nMp3Pos=0;
			return;
		 }
		ucStatus = LD_ReadReg(0x06);
		
	}

}


//void LD_ReloadMp3Data()
//{
//	u32 nCurMp3Pos;
//	u8 val;
//	u8 k;
//
//	nCurMp3Pos = nMp3StartPos + nMp3Pos;
////	FLASH_CS=1;
////	FLASH_CLK=0;
////	FLASH_CS=0;
//
//	 IO_Send_Byte(W25P_FastReadData);   
//	 IO_Send_Byte(((nCurMp3Pos & 0xFFFFFF) >> 16));  
//	 IO_Send_Byte(((nCurMp3Pos & 0xFFFF) >> 8));
//	 IO_Send_Byte(nCurMp3Pos & 0xFF);
//	 IO_Send_Byte(0xFF);
//
//	ucStatus = LD_ReadReg(0x06);
//	while ( !(ucStatus&MASK_FIFO_STATUS_AFULL) && (nMp3Pos<nMp3Size) )
//	{
//		val=0;
//		for(k=0;k<8;k++)
//		{
//			FLASH_CLK=0;
//			val<<=1;
//			FLASH_CLK=1;
//			val|=FLASH_DO;
//		}
//		LD_WriteReg(0x01,val);
//
//		nMp3Pos++;
//
//		ucStatus = LD_ReadReg(0x06);
//	}
//	
//	FLASH_CS=1;
//	FLASH_CLK=0;
//
//}


void LD_play(void)
{
	nMp3Pos=0;
	bMp3Play=1;

	if (nMp3Pos >=  nMp3Size)
		return ; 

	LD_ReloadMp3Data(100);						   //MP3

    LD_WriteReg(0xBA, 0x00); //					   
	LD_WriteReg(0x17, 0x48);					   //DSP
	LD_WriteReg(0x33, 0x01);					   //ʼ
	LD_WriteReg(0x29, 0x04);
												  
	LD_WriteReg(0x02, 0x01); 					  //FIFO_DATAж
	LD_WriteReg(0x85, 0x5A);					  //

}





u8 ASR_interrupt(void)
{
	u8 nAsrResCount=0;									   //Ҹ

//	ucRegVal = LD_ReadReg(0x2B);						   //ȡж
//	if(nLD_Mode == LD_MODE_ASR_RUN)
//	{
		// ʶж
		// 룬ʶɹʧܶжϣ
		LD_WriteReg(0x29,0) ;								//رж
		LD_WriteReg(0x02,0) ;								//رж
		if((ucRegVal & 0x10) &&								//жǷΪж
			LD_ReadReg(0xb2)==0x21 && 						//жоƬǷ
			LD_ReadReg(0xbf)==0x35)							//жʶǷ
		{
			nAsrResCount = LD_ReadReg(0xba);				 //ȡжٸʶѡΪ0-4
			if(nAsrResCount>4)
			  nAsrResCount=0;								 //4ǳ
			else
			  nAsrStatus = LD_ASR_FOUNDOK;
		}
		else
		{
			nAsrResCount=0;
			nAsrStatus = LD_ASR_NONE;
		}
			
		LD_WriteReg(0x2b, 0);								 //ж
    	LD_WriteReg(0x1C,0);								 //رADC

//	}
		return nAsrResCount;
}

void  play_interrupt(void)
{	
	ucHighInt = LD_ReadReg(0x29); 
	ucLowInt=LD_ReadReg(0x02); 
	LD_WriteReg(0x29,0) ;
	LD_WriteReg(0x02,0) ;
    if(LD_ReadReg(0xBA)&CAUSE_MP3_SONG_END)
    {
	// A. ȫꡣ

		LD_WriteReg(0x2B,LD_ReadReg(0x2B)&(~MASK_INT_SYNC));	
      	LD_WriteReg(0xBA, 0);	
		LD_WriteReg(0xBC,0x0);	
		bMp3Play=0;					// ȫ޸bMp3Playı
		LD_WriteReg(0x08,1);
		delay_ms(5);
      	LD_WriteReg(0x08,0);
		LD_WriteReg(0x33, 0);

		return ;
     }

	 if(nMp3Pos>=nMp3Size)
	{
	// B. ѷϡ

		LD_WriteReg(0xBC,0x01);
		ucStatus = LD_ReadReg(0x02);
		ucStatus&=(~MASK_AFIFO_INT);
		LD_WriteReg(0x02, ucStatus);
		ucStatus=LD_ReadReg(0x29);
		ucStatus&=(~MASK_INT_FIFO);  
		LD_WriteReg(0x29,ucStatus|MASK_INT_SYNC) ;
//		bMp3Play=0;				//	ʱֻMCUMP3ݷ͵LD3320оƬڣǻûаȫ
		return;	
	}
 }
 void EXTI9_5_IRQHandler(void)
{
	if(LD3320_INTB==0)	
	{
//	    ucRegVal = LD_ReadReg(0x2B);						   //ȡж
//		if(nLD_Mode == LD_MODE_ASR_RUN)						   //ʾʶн
//			ASR_interrupt();
//		else if(nLD_Mode ==LD_MODE_MP3)							   //MP3
//			play_interrupt();
        ProcessInt0();
	}		 
	EXTI->PR=1<<5;  //LINE1ϵжϱ־λ  
}

void ProcessInt0(void)	  //յʶⲿжϴ
{
	u8 nAsrResCount=0;

//	EX0=0;			 //رⲿжϣݺ¿
	
	ucRegVal = LD_ReadReg(0x2B);
	if(nLD_Mode == LD_MODE_ASR_RUN)
	{
		// ʶж
		// 룬ʶɹʧܶжϣ
		LD_WriteReg(0x29,0) ;
		LD_WriteReg(0x02,0) ;
		if((ucRegVal & 0x10) &&	LD_ReadReg(0xb2)==0x21 && LD_ReadReg(0xbf)==0x35)
		{
			nAsrResCount = LD_ReadReg(0xba);
			if(nAsrResCount>0 && nAsrResCount<=4) 
			{
				nAsrStatus=LD_ASR_FOUNDOK;
			}
			else
		    {
				nAsrStatus=LD_ASR_FOUNDZERO;
			}	
		}
		else
		{
			nAsrStatus=LD_ASR_FOUNDZERO;
		}
			
		LD_WriteReg(0x2b, 0);
    	LD_WriteReg(0x1C,0);
		return;
	}
	
	// Ųжϣ֣
	// A. ȫꡣ
	// B. ѷϡ
	// C. ʱҪ꣬Ҫµݡ	
	ucHighInt = LD_ReadReg(0x29); 
	ucLowInt=LD_ReadReg(0x02); 
	LD_WriteReg(0x29,0) ;
	LD_WriteReg(0x02,0) ;
    if(LD_ReadReg(0xBA)&CAUSE_MP3_SONG_END)
    {
	// A. ȫꡣ

		LD_WriteReg(0x2B, 0);
      	LD_WriteReg(0xBA, 0);	
		LD_WriteReg(0xBC,0x0);	
		bMp3Play=0;					// ȫ޸bMp3Playı
		LD_WriteReg(0x08,1);
		delay_ms(10);
      	LD_WriteReg(0x08,0);
		LD_WriteReg(0x33, 0);	 
		return ;
     }

	 if(nMp3Pos>=nMp3Size)
	{
	// B. ѷϡ

		LD_WriteReg(0xBC, 0x01);
		LD_WriteReg(0x29, 0x10);
		bMp3Play=0;				//	ʱֻMCUMP3ݷ͵LD3320оƬڣǻûаȫ
//		EX0=1; //ⲿݣⲿж	  
		return;	
	}

	// C. ʱҪ꣬Ҫµݡ	 
	LD_ReloadMp3Data2(100);
		
	LD_WriteReg(0x29,ucHighInt); 
	LD_WriteReg(0x02,ucLowInt) ;

	delay_ms(20);
//	EX0=1; //ⲿݣⲿж	  	
}


void ASR_Exit_Init(void)
{
    RCC->APB2ENR|=1<<4;
	GPIOC_IN_L(5);
	GPIOC_SET(5);
    Ex_NVIC_Config(GPIO_C,5,FTIR);//½ش
	MY_NVIC_Init(1,1,EXTI9_5_IRQChannel,2);//ռ1ȼ12	   
}
void ASR_DL3320_Init(void)
{
	ASR_Exit_Init();
	GPIOC_TIME_ENABLE;
	GPIOA_TIME_ENABLE;
	GPIOC_OUT_L(4);
	GPIOA_OUT_L(4);
	GPIOA_OUT_L(7);
	GPIOA_IN_L(6);
	GPIOA_SET(6);
	GPIOA_OUT_L(5);
	LD3320_reset();					//λʶ
	LCD_ShowString(100,0,"0x06");
	LCD_ShowString(100,16,"0x06");
	LCD_ShowString(100,32,"0x35");
	LCD_ShowString(100,48,"0xb3");
	LCD_ShowNum(170,0,LD_ReadReg(0x06),3,16);
	LCD_ShowNum(170,16,LD_ReadReg(0x06),3,16);
	LCD_ShowNum(170,32,LD_ReadReg(0x35),3,16);
	LCD_ShowNum(170,48,LD_ReadReg(0xb3),3,16);
}


void PlaySound(u8 nCode)
{
	if (nCode>=ITEM_COUNT)
		return;		

//	nMp3StartPos = pAsrItem[nCode].nSoundStart;
//	nMp3Size = pAsrItem[nCode].nSoundSize;

//	SendString("PlaySound - ");	   //¼ΪӴڴӡϢPCĺ߿ֱӵ
//	SendByteHex(nCode);
//	SendLongHex(nMp3StartPos);
//	SendLongHex(nMp3Size);
//	SendLineEnd();

	LD_Init_MP3();
	LD_AdjustMIX2SPVolume(7);		//
	LD_play();
}

//void PlaySound(u8 nCode)
//{
////	switch(nCode)
////	{
////	case CODE_BEIJING:
////		nMp3StartPos = MP3_BEIJING_START;
////		nMp3Size = MP3_BEIJING_SIZE;
////		break;
////	case CODE_SHANGHAI:
////		nMp3StartPos = MP3_SHANGHAI_START;
////		nMp3Size = MP3_SHANGHAI_SIZE;
////		break;
////	case CODE_TIANJIN:
////		nMp3StartPos = MP3_TIANJIN_START;
////		nMp3Size = MP3_TIANJIN_SIZE;
////		break;
////	case CODE_CHONGQING:
////		nMp3StartPos = MP3_CHONGQING_START;
////		nMp3Size = MP3_CHONGQING_SIZE;
////		break;
////	default:
////		nMp3StartPos = MP3_NIHAO_START;
////		nMp3Size = MP3_NIHAO_SIZE;
////		break;		
////	}
//
//	LD_Init_MP3();
//	LD_AdjustMIX2SPVolume(8);
//	LD_play();
//}


/*ʶ*/
void ASR_judge(void)
{	
	switch(nAsrStatus)
		{
			case LD_ASR_RUNING:	break;		   //ASR
			case LD_ASR_ERROR:
			            			   //ASRд
				   nAsrStatus = LD_ASR_NONE;
				break;
			case LD_ASR_NONE:			   //ûASR
			{
				//FlashLED(1);

				nAsrStatus=LD_ASR_RUNING;  //flagΪ
				if (RunASR()==0)		   //	һASRʶ̣ASRʼASRӹؼASR
				{
					nAsrStatus = LD_ASR_ERROR;	   //ASRflag
				}
				break;
			}
			case LD_ASR_FOUNDOK:			//ASR
			{
				nAsrRes = LD_GetResult();	//	һASRʶ̽ȥȡASRʶ
			//	OutputIO(nAsrRes);			//  ʶӦIOܽ1ҵĵ͵ƽ߿ͨIOܽ豸ء
				if(nAsrRes<12)					//峤ȺͲһ£жϷֵǷҪ
				{	
//				    LD_Init_MP3();				 //ųʼ
					PlaySound(nAsrRes);	    //  ʶ úųʼ				
				}
                POINT_COLOR=BLACK;//Ϊɫ
                LCD_ShowNum(100,160,nAsrRes,3,16);
				nAsrStatus = LD_ASR_NONE;				
				break;
			}
			case LD_ASR_FOUNDZERO:	
			         	//δֽ
			default:
			{
				//FlashLED(1);
				//PlaySound(0);
				nAsrStatus = LD_ASR_NONE;
				break;
			}
		}
}

/*
 ʶⲿ
*/
u8 RunASR(void)
{
	u8 i=0;
	u8 asrflag=0;
	for (i=0; i<5; i++)			//	ֹӲԭLD3320оƬһ5ASRʶ
	{
		LD_Init_ASR();				 //ʶʼ
		delay_ms(30);
		if (LD_AsrAddFixed()==0)
		{
			LD3320_reset();			//	LD3320оƬڲֲLD3320оƬ
			delay_ms(30);			//	ӳʼʼASRʶ
			continue;
		}
		POINT_COLOR=BLACK;//Ϊɫ
		LCD_ShowString(0,148,"0xBF");
		LCD_ShowNum(40,148,LD_ReadReg(0xBf),3,16);
		delay_ms(10);
		if (LD_AsrRun() == 0)
		{
			LD3320_reset();			//	LD3320оƬڲֲLD3320оƬ
			delay_ms(30);			//	ӳʼʼASRʶ
			continue;
		}

		asrflag=1;
		break;					//	ASRɹ˳ǰforѭʼȴLD3320ͳжź
	}

	return asrflag;
}


//
//void LD_AsrAddFixed_ByIndex(u8 nIndex)
//{
//	switch(nIndex)
//	{
//		case  0: LD_AsrAddFixed_ByString(STR_00,nIndex); break;
//		case  1: LD_AsrAddFixed_ByString(STR_01,nIndex); break;
//		case  2: LD_AsrAddFixed_ByString(STR_02,nIndex); break;
//		case  3: LD_AsrAddFixed_ByString(STR_03,nIndex); break;
//		case  4: LD_AsrAddFixed_ByString(STR_04,nIndex); break;
//		case  5: LD_AsrAddFixed_ByString(STR_05,nIndex); break;
//		case  6: LD_AsrAddFixed_ByString(STR_06,nIndex); break;
//		case  7: LD_AsrAddFixed_ByString(STR_07,nIndex); break;
//		case  8: LD_AsrAddFixed_ByString(STR_08,nIndex); break;
//		case  9: LD_AsrAddFixed_ByString(STR_09,nIndex); break;
//		case 10: LD_AsrAddFixed_ByString(STR_10,nIndex); break;
//		case 11: LD_AsrAddFixed_ByString(STR_11,nIndex); break;
//		case 12: LD_AsrAddFixed_ByString(STR_12,nIndex); break;
//		case 13: LD_AsrAddFixed_ByString(STR_13,nIndex); break;
//		case 14: LD_AsrAddFixed_ByString(STR_14,nIndex); break;
//		case 15: LD_AsrAddFixed_ByString(STR_15,nIndex); break;
//		case 16: LD_AsrAddFixed_ByString(STR_16,nIndex); break;
//		case 17: LD_AsrAddFixed_ByString(STR_17,nIndex); break;
//		case 18: LD_AsrAddFixed_ByString(STR_18,nIndex); break;
//		case 19: LD_AsrAddFixed_ByString(STR_19,nIndex); break;
//		case 20: LD_AsrAddFixed_ByString(STR_20,nIndex); break;
//		case 21: LD_AsrAddFixed_ByString(STR_21,nIndex); break;
//		case 22: LD_AsrAddFixed_ByString(STR_22,nIndex); break;
//		case 23: LD_AsrAddFixed_ByString(STR_23,nIndex); break;
//		case 24: LD_AsrAddFixed_ByString(STR_24,nIndex); break;
//		case 25: LD_AsrAddFixed_ByString(STR_25,nIndex); break;
//		case 26: LD_AsrAddFixed_ByString(STR_26,nIndex); break;
//		case 27: LD_AsrAddFixed_ByString(STR_27,nIndex); break;
//		case 28: LD_AsrAddFixed_ByString(STR_28,nIndex); break;
//		case 29: LD_AsrAddFixed_ByString(STR_29,nIndex); break;
//		case 30: LD_AsrAddFixed_ByString(STR_30,nIndex); break;
//		case 31: LD_AsrAddFixed_ByString(STR_31,nIndex); break;
//		case 32: LD_AsrAddFixed_ByString(STR_32,nIndex); break;
//		case 33: LD_AsrAddFixed_ByString(STR_33,nIndex); break;
//		case 34: LD_AsrAddFixed_ByString(STR_34,nIndex); break;
//		case 35: LD_AsrAddFixed_ByString(STR_35,nIndex); break;
//		case 36: LD_AsrAddFixed_ByString(STR_36,nIndex); break;
//		case 37: LD_AsrAddFixed_ByString(STR_37,nIndex); break;
//		case 38: LD_AsrAddFixed_ByString(STR_38,nIndex); break;
//		case 39: LD_AsrAddFixed_ByString(STR_39,nIndex); break;
//		case 40: LD_AsrAddFixed_ByString(STR_40,nIndex); break;
//		case 41: LD_AsrAddFixed_ByString(STR_41,nIndex); break;
//		case 42: LD_AsrAddFixed_ByString(STR_42,nIndex); break;
//		case 43: LD_AsrAddFixed_ByString(STR_43,nIndex); break;
//		case 44: LD_AsrAddFixed_ByString(STR_44,nIndex); break;
//		case 45: LD_AsrAddFixed_ByString(STR_45,nIndex); break;
//		case 46: LD_AsrAddFixed_ByString(STR_46,nIndex); break;
//		case 47: LD_AsrAddFixed_ByString(STR_47,nIndex); break;
//		case 48: LD_AsrAddFixed_ByString(STR_48,nIndex); break;
//		case 49: LD_AsrAddFixed_ByString(STR_49,nIndex); break;	 
//	}		
//}



//u8 LD_AsrAddFixed()
//{
//	u8 k, flag; 			
//
//	flag = 1;
//	for (k=0; k<ITEM_COUNT; k++)
//	{	 			
//		if(LD_Check_ASRBusyFlag_b2() == 0)
//		{
//			flag = 0;
//			break;
//		}		
//		LD_AsrAddFixed_ByIndex(k);
//	}
//    return flag;
//}




//void LD_AsrAddFixed_ByString(char * pRecogString, u8 k)
//{
//	u8 nAsrAddLength;
//
//	if (*pRecogString==0)
//		return;
//
//	LD_WriteReg(0xc1, k );
//	LD_WriteReg(0xc3, 0 );
//	LD_WriteReg(0x08, 0x04);
//	delay_ms(1);
//	LD_WriteReg(0x08, 0x00);
//	delay_ms(1);	
//
//	for (nAsrAddLength=0; nAsrAddLength<50; nAsrAddLength++)
//	{
//		if (pRecogString[nAsrAddLength] == 0)
//			break;
//		LD_WriteReg(0x5, pRecogString[nAsrAddLength]);
//	}
//	
//	LD_WriteReg(0xb9, nAsrAddLength);
//	LD_WriteReg(0xb2, 0xff);
//	LD_WriteReg(0x37, 0x04);
//}
//¼ΪӴڴӡϢPCĺ߿ֱӵ
void SendChar (u8 data_to_tx) 
{
#ifdef LD_DEBUG
	ES	  =		0;  //شж
	TI    =   0;  //㴮ڷж־
	SBUF  =  data_to_tx;
	while(TI==0); //ȴ
	TI    =   0;
	ES    =   1;  //ж
#endif
}

void SendLineEnd(void) 
{
#ifdef LD_DEBUG
	SendChar(0x0D);
	SendChar(0x0A);
#endif
}

void SendString(unsigned char *pt)
{
#ifdef LD_DEBUG
    while(*pt)
		SendChar(*(pt++));
#endif
}

void SendByteHex (u8 value)
{
#ifdef LD_DEBUG
	uint8 idata ch1 = value & 0xF0;
	ch1 = ch1>>4;
	if (ch1>9)
		ch1 = 'A' + ch1 - 10;
	else 
		ch1 = '0' + ch1;
	SendChar(ch1);
	ch1 = value & 0x0F;
	if (ch1>9)
		ch1 = 'A' + ch1 - 10;
	else 
		ch1 = '0' + ch1;
	SendChar(ch1);
	SendChar(' ');
#endif
}

void SendLongHex (u32 value)
{
#ifdef LD_DEBUG
	uint8 idata bt;
	SendChar('[');
	bt = (uint8)(value>>24);
	SendByteHex(bt);
	bt = (uint8)((value&0x00FF0000L)>>16);
	SendByteHex(bt);
	bt = (uint8)((value&0x0000FF00L)>>8);
	SendByteHex(bt);
	bt = (uint8)((value&0x000000FFL));
	SendByteHex(bt);
	SendChar(']');
	SendChar(' ');
#endif
}
