/*ISD1760¼  */
/************************************************************************** 
*    SPIISD1760 
*    SPIISD1760 
**************************************************************************/ 
#include <stm32f10x_lib.h>
#include "sys.h"
#include "isd1760.h"
#include "delay.h"
#include "usart.h"

u8 SR0_L; 
u8 SR0_H; 
u8 SR1; 
u8 ID,APCL=0,APCH=0; 
u8 SBUF=0;
u16 caToneAdd[90];
/************************************************************************** 
*    ԭ: void ISD_SPI_Init(void) 
*        : IOڳʼ 
**************************************************************************/
void ISD_SPI_Init(void)
{
    RCC->APB2ENR|=1<<3;    //ʹPORTBʱ	
	   	 
	GPIOB->CRH&=0XFF0FFFFF; 
	GPIOB->CRH|=0X00300000;//PB13  --SCLK 	 
    GPIOB->ODR|=1<<13;      //PB13 
	
	GPIOB->CRH&=0X0FFFFFFF; 
	GPIOB->CRH|=0X30000000;//PB15   --MOSI 	 
    GPIOB->ODR|=1<<15;      //PB15 
	
	GPIOB->CRH&=0XFFF0FFFF; 
	GPIOB->CRH|=0X00030000;//PB12   --SS	 
    GPIOB->ODR|=1<<12;      //PB12 
	
	GPIOB->CRH&=0XF0FFFFFF;//PB14   --MISO
	GPIOB->CRH|=0X08000000;
	GPIOB->ODR|=1<<14;      
}
/************************************************************************** 
*    ԭ: void ISD_Init(void); 
*        : ʼ 
**************************************************************************/ 
void  ISD_Init(void)
{ 
	ISD_Reset(); 
	do{ 
	ISD_PU();	
	delay_ms(50); 
	RdStatus();
	}while((SR0_L&0x01)||!(SR1&0x01)); //if(SR0_L^0==1){system Err}<CMD_Err==1>  
	SBUF=RD_DevID();//ȡоƬID,----1760Ϊ0xa0 
	ClrInt(); 
	ISD_CHK_MEM();
	ISD_WR_APC2(0xa0); 
	delay_ms(50);
	RdAPC(); 
} 

/************************************************************************** 
*    ԭ: void ISD_PU(void); 
*        : ռ 
**************************************************************************/ 
void ISD_CHK_MEM(void)
{ 
	ISD_SendData(CHK_MEM); 
	ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10); 
} 

/************************************************************************** 
*    ԭ: void ISD_PU(void); 
*        : ϵ 
**************************************************************************/ 
void ISD_PU(void)
{ 
	ISD_SendData(PU|0x10); 
	ISD_SendData(0x00); 
	SS=1; 
	delay_ms(50); 
} 

/************************************************************************** 
*    ԭ: void ISD_Reset(void); 
*        : λ 
**************************************************************************/ 
void ISD_Reset(void)
{ 
	ISD_SendData(RESET); 
	ISD_SendData(0x00); 
	SS=1; 
    delay_ms(50); 
} 

/************************************************************************* 
*    ԭ: void ISD_SendData(u8 BUF_ISD); 
*        :  
**************************************************************************/ 

u8 ISD_SendData(u8 BUF_ISD)
{ 
	u8 i,dat; 
	dat=BUF_ISD;
	SS=0; 
   	delay_us(18);
	for(i=0;i<8;i++)
	{ 
		SCLK=0; 
		delay_us(18); 
		if(dat&0x01)
		{ 
			MOSI=1; 
		} 
		else
		{ 
			MOSI=0; 
		} 
		dat>>=1; 	
		SCLK=1; 
		delay_us(18); 
		if(MISO)
		{
			dat|=0x80; 
		} 
	} 
	MOSI=0; 
	delay_us(18);
	return(dat); 
} 	 

/************************************************************************** 
*    ԭ: void RdStatus(void); 
*        : ȡ״̬ 
**************************************************************************/ 
void RdStatus(void)
{ 
	ISD_SendData(RD_STATUS); 
	ISD_SendData(0x00); 
	ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10);               //ӳ10ms 
	SR0_L =ISD_SendData(RD_STATUS); 
	SR0_H =ISD_SendData(0x00); 
	SR1 =ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10); 
} 

/************************************************************************** 
*    ԭ: void RdStatus(void); 
*        : ȡID 
**************************************************************************/ 
u8 RD_DevID(void)
{ 
	ISD_SendData(RD_DEVID); 
	ISD_SendData(0x00); 
	ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10);               //ӳ10ms 
	SR0_L =ISD_SendData(RD_DEVID); 
	SR0_H =ISD_SendData(0x00); 
	ID =ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10); 
	return(ID); 
} 

/************************************************************************** 
*    ԭ: void RD_APC(void); 
*        : ȡAPC 
**************************************************************************/ 
void RdAPC(void)
{ 
	ISD_SendData(RD_APC); 
	ISD_SendData(0x00); 
	ISD_SendData(0x00); 
	ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10);               //ӳ10ms 
	
	SR0_L =ISD_SendData(RD_APC); 
	SR0_H =ISD_SendData(0x00); 
	APCL =ISD_SendData(0x00); 
	APCH =ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10);               //ӳ10ms 
} 

/************************************************************************** 
*    ԭ: void ClrInt(void); 
*        : ж 
**************************************************************************/ 
void ClrInt(void)
{ 
	ISD_SendData(CLR_INT); 
	ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10);               //ӳ10ms 
} 

/************************************************************************** 
*    ԭ: void ISD_WR_APC2(u8 voiceValue); 
*        : APC2 
**************************************************************************/ 
void ISD_WR_APC2(u8 voiceValue)
{ 
	ISD_SendData(WR_APC2); 
	ISD_SendData(voiceValue); //3λΪ
	ISD_SendData(0x04); //0x04 EOM=0,VALERT=1 0x 0C EOM=1
	SS=1; 
	delay_ms(10);               //ӳ10ms 
	ISD_WR_NVCFG(); //дĴ/˳ڷҪʱҪӣ 
} 

/************************************************************************** 
*    ԭ: void ISD_WR_NVCFG(void); 
*        : дĴ 
**************************************************************************/ 
void ISD_WR_NVCFG(void)
{ 
	ISD_SendData(WR_NVCFG); 
	ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10);               //ӳ10ms 
} 

/************************************************************************** 
*    ԭ: void SetPLAY(u8 cNum); 
*        : 㲥 
**************************************************************************/ 
void SetPLAY(u8 cNum)
{ 
	u16 Add_ST,Add_ED;
	u8  Add_ST_H, Add_ST_L, Add_ED_H, Add_ED_L; 
	
	do{ 
	RdStatus(); 
	}while((SR0_L&0x01)||!(SR1&0x01)); //if(SR0_L^0==1){system Err}<CMD_Err==1> 
	
	ClrInt(); 
	Add_ST=caToneAdd[cNum*2];
	Add_ED=caToneAdd[cNum*2+1];
	Add_ST_L=(u8)(Add_ST&0x00ff); 
	Add_ST_H=(u8)((Add_ST>>8)&0x00ff); 
	Add_ED_L=(u8)(Add_ED&0x00ff); 
	Add_ED_H=(u8)((Add_ED>>8)&0x00ff); 
	ISD_SendData(SET_PLAY); 
	ISD_SendData(0x00); 
	ISD_SendData(Add_ST_L);          //S7:S0  ʼַ 
	ISD_SendData(Add_ST_H);           //S10:S8 
	ISD_SendData(Add_ED_L);           //E7:E0  ַ 
	ISD_SendData(Add_ED_H);           //E10:E8 
	ISD_SendData(0x00); 
	SS=1; 
	delay_ms(10);               //ӳ10ms 
	do{ 				        //ȴɣע͵ʵֲݵĴ
	RdStatus(); 	  
	}while((SR0_L&0x01)||(SR1&0x04)); //if(SR0_L^0==1){system Err}<CMD_Err==1> 

} 
/************************************************************************** 
*    ԭ: void ISD_PD(void); 
*        :  
**************************************************************************/  
void ISD_PD(void)
{ 
	ISD_SendData(PD); 
	ISD_SendData(0x00); 
	SS=1; 
} 

/************************************************************************** 
*    END 
*    END 
**************************************************************************/ 


