#include "pid.h"
#include "lcd.h"

struct  PID  pid;
void PIDInit(struct PID *sptr) 
{  
	sptr->SumError = 0; 
	sptr->LastError = 0; //Error[-1]  
	sptr->PrevError = 0; //Error[-2] 
	sptr->Proportion = 0; // Proportional Const  
	sptr->Integral = 0; //ֳIntegral Const  
	sptr->Derivative = 0; //΢ֳ Derivative Const  
	sptr->SetPoint 	=0;
	sptr->LastPoint	=0;
	sptr->PrevPoint	=0;	
} 

/*====================================================================================================
   PID㲿
=====================================================================================================*/

/******************************׼ʽPID************************************/
//׼ʽPID	 ֵΪ        //ˮλ¶ȣۻЧĶ
int Standard_incremental_PID(struct PID *pp, int NextPoint)
{
    int  pidcalc,Error;
    Error = pp->SetPoint - NextPoint;     //ƫ
	 
	pidcalc =  pp->Proportion * (Error-pp->LastError) // E[k]-E[k-1]
			 + pp->Integral * Error // E[k]
			 + pp->Derivative * (Error-2*pp->LastError+pp->PrevError); //E[k]-2*E[k-1]+E[k-2]	
    
	 //洢´μ
    pp->PrevError = pp->LastError;
    pp->LastError = Error;
 
	return (pidcalc); 		//ֵ
} 

/*****************************Ǳ׼ʽPID********************************/
//Ǳ׼ʽPID ֵΪ
int incremental_PID(struct PID *pp,int NextPoint)
{
    int  pidcalc,Error;
    Error = pp->SetPoint - NextPoint;		// 
	 
	pidcalc =  pp->Proportion * Error // E[k]
			 - pp->Integral * pp->LastError // E[k-1]
			 + pp->Derivative * pp->PrevError; // E[k-2]
    
    pp->PrevError = pp->LastError;		 //洢´μ
    pp->LastError = Error;
 
	return (pidcalc);			//ֵ
} 

/******************************Ǳ׼λʽPID*********************************/
int position_PID(struct PID *pp,int NextPoint)
{
	int dError,Error,gappid;
 
	Error = pp->SetPoint - NextPoint; 	 //	ƫ
    dError = pp->LastError - pp->PrevError;     // ΢ּ
	pp->SumError+=(Error/10);					   //ۻ
	gappid =(pp->Proportion*Error/10)
			  + (pp->Integral * pp->SumError/10)
			  + pp->Derivative*dError;

	gappid=gappid/10;
    pp->PrevError = pp->LastError;
    pp->LastError =Error;
	return gappid ;		
}

/***************************׼λʽPID*************************/
int standard_position_PID(struct PID *pp,int NextPoint)        //ۻЧĶֱ
{
	int last_gappid,Error,gappid;
	Error = pp->SetPoint - NextPoint; 	 //	ƫ

	gappid =  last_gappid
		  	+ pp->Proportion * (Error-pp->LastError) // E[k]-E[k-1]
			+ pp->Integral * Error // E[k]
		    + pp->Derivative * (Error-2*pp->LastError+pp->PrevError); //E[k]-2*E[k-1]+E[k-2]	

    pp->PrevError = pp->LastError;
    pp->LastError =Error;
	last_gappid=gappid;
	return gappid ;			
}

/*********************ַ׼λʽPID㷨*************************/
int Integral_separation_position_PID(struct PID *pp,int NextPoint,u8 Q)
{
	int last_gappid,Error,gappid;
	Error = pp->SetPoint - NextPoint; 	 //	ƫ

	gappid =  last_gappid
		  	+ pp->Proportion * (Error-pp->LastError) // E[k]-E[k-1]
			+Q * pp->Integral * Error // E[k]			   //Q=0;ַ룬
		    + pp->Derivative * (Error-2*pp->LastError+pp->PrevError); //E[k]-2*E[k-1]+E[k-2]	

    pp->PrevError = pp->LastError;
    pp->LastError =Error;
	last_gappid=gappid;
	return gappid ;			
}

/*******************ַ׼ʽPID㷨*****************************/
int Integral_separation_incremental_PID(struct PID *pp, int NextPoint,u8 Q)
{
	int  pidcalc,Error;
    Error = pp->SetPoint - NextPoint;     //ƫ
	 
	pidcalc =  pp->Proportion * (Error-pp->LastError) // E[k]-E[k-1]
			 + Q * pp->Integral * Error // E[k]		   Q=0,ַ룬
			 + pp->Derivative * (Error-2*pp->LastError+pp->PrevError); //E[k]-2*E[k-1]+E[k-2]	
    
	 //洢´μ
    pp->PrevError = pp->LastError;
    pp->LastError = Error;
 
	return (pidcalc); 		//ֵ
}

/**************************΢ʽPID㷨********************************/
int Differential_forward_incremental_PID(struct PID *pp, int NextPoint)		   //Ӧ趨ֵƵĳ
{
	int  pidcalc,Error;
    Error = pp->SetPoint - NextPoint;     //ƫ
	 
	pidcalc =  pp->Proportion * (Error-pp->LastError) // E[k]-E[k-1]
			 + pp->Integral * Error // E[k]		   Q=0,ַ룬
			 + pp->Derivative * (NextPoint-2*pp->LastPoint+pp->PrevPoint); //E[k]-2*E[k-1]+E[k-2]	
    
	 //洢´μ
	pp->PrevPoint = pp->LastPoint;
	pp->LastPoint = NextPoint;

    pp->PrevError = pp->LastError;
    pp->LastError = Error;
 
	return (pidcalc); 		//ֵ		
}
