#ifndef __PID_H
#define __PID_H
#include "stm32f10x_lib.h"

struct PID 
{ 
	int  SetPoint;           //  趨Ŀ Desired Value
	int  LastPoint;
	int  PrevPoint;
    int  Proportion;         //   Proportional Const
    int  Integral;           //  ֳ Integral Const
    int  Derivative;         //  ΢ֳ Derivative Const
    int  LastError;          //  Error[-1]
    int  PrevError;          //  Error[-2]
    int  SumError;           //  Sums of Errors
};

extern struct  PID  pid;
void PIDInit(struct PID *sptr);
int Standard_incremental_PID(struct PID *pp, int NextPoint);
int incremental_PID(struct PID *pp,int NextPoint);
int standard_position_PID(struct PID *pp,int NextPoint);
int position_PID(struct PID *pp,int NextPoint);
int Integral_separation_position_PID(struct PID *pp,int NextPoint,u8 Q);
int Integral_separation_incremental_PID(struct PID *pp, int NextPoint,u8 Q);
int Differential_forward_incremental_PID(struct PID *pp, int NextPoint);

#endif
